//
// @(#) ads_vlog_prim.v 1.4@(#)
// 8/12/96  21:23:49
//
// author: CADENCE Design Systems, Inc.
// email:  indovina@cadence.com
// (c) 1993, 1994, 1995 CADENCE Design Systems, Inc.
// (c) 8/12/96 21:23:49 CADENCE Design Systems, Inc.
//
// sync primitives
//

`celldefine
primitive ads_prim_dff_sr_p ( q, d, s, r, clk ) ;
  output q ;
  input d, s, r, clk ;
// d flip-flop, posedge clk, set, reset
  reg q ;
  table
//   d s r clk : q : q+1
     ? ? 1  ?  : ? : 0;
     ? 1 0  ?  : ? : 1;
     0 0 0  r  : ? : 0;
     1 0 0  r  : ? : 1;
//----------------------
     0 0 0  ?  : 0 : 0;
     1 0 0  ?  : 1 : 1;
//----------------------
     ? ? ? (?0): ? : -;
  (??) ? ?  ?  : ? : -;
     ? ? f  0  : ? : -;
     ? ? f  1  : ? : -;
     ? f ?  0  : ? : -;
     ? f ?  1  : ? : -;
    endtable
endprimitive
`endcelldefine

`celldefine
primitive ads_prim_dff_sr_n ( q, d, s, r, clk ) ;
  output q ;
  input d, s, r, clk ;
// d flip-flop, negedge clk, set, reset
  reg q ;
  table
//   d s r clk : q : q+1
     ? ? 1  ?  : ? : 0;
     ? 1 0  ?  : ? : 1;
     0 0 0  f  : ? : 0;
     1 0 0  f  : ? : 1;
//----------------------
     0 0 0  ?  : 0 : 0;
     1 0 0  ?  : 1 : 1;
//----------------------
     ? ? ? (?1): ? : -;
  (??) ? ?  ?  : ? : -;
     ? ? f  0  : ? : -;
     ? ? f  1  : ? : -;
     ? f ?  0  : ? : -;
     ? f ?  1  : ? : -;
    endtable
endprimitive
`endcelldefine

`celldefine
primitive ads_prim_lat_sr_p (q, d, e, s, r);
   output q;
   input d,e,s,r;
// latch, active high enable, set, reset
   reg q;
   table
// d e s r q_state q
   ? ? ? 1 :  ?  : 0;
   ? ? 1 0 :  ?  : 1;
   1 1 0 0 :  ?  : 1;
   0 1 0 0 :  ?  : 0;
   ? 0 0 0 :  ?  : -;
   0 ? 0 ? :  0  : 0;
   1 ? ? 0 :  1  : 1;
   endtable
endprimitive
`endcelldefine

`celldefine
primitive ads_prim_lat_sr_n (q, d, e, s, r);
   output q;
   input d,e,s,r;
// latch, active low enable, set, reset
   reg q;
   table
// d e s r q_state q
   ? ? ? 1 :  ?  : 0;
   ? ? 1 0 :  ?  : 1;
   1 0 0 0 :  ?  : 1;
   0 0 0 0 :  ?  : 0;
   ? 1 0 0 :  ?  : -;
   0 ? 0 ? :  0  : 0;
   1 ? ? 0 :  1  : 1;
   endtable
endprimitive
`endcelldefine

`celldefine
primitive ads_prim_dff_pc_p ( q, d, p, c, clk ) ;
  output q ;
  input d, p, c, clk ;
// d flip-flop, posedge clk, preset, clear
  reg q ;
  table
//   d p c clk : q : q+1
     ? ? 0  ?  : ? : 0;
     ? 0 1  ?  : ? : 1;
     0 1 1  r  : ? : 0;
     1 1 1  r  : ? : 1;
//----------------------
     0 1 1  ?  : 0 : 0;
     1 1 1  ?  : 1 : 1;
//----------------------
     ? ? ? (?0): ? : -;
  (??) ? ?  ?  : ? : -;
     ? ? r  0  : ? : -;
     ? ? r  1  : ? : -;
     ? r ?  0  : ? : -;
     ? r ?  1  : ? : -;
    endtable
endprimitive
`endcelldefine

`celldefine
primitive ads_prim_dff_pc_n ( q, d, p, c, clk ) ;
  output q ;
  input d, p, c, clk ;
// d flip-flop, negedge clk, preset, clear
  reg q ;
  table
//   d p c clk : q : q+1
     ? ? 0  ?  : ? : 0;
     ? 0 1  ?  : ? : 1;
     0 1 1  f  : ? : 0;
     1 1 1  f  : ? : 1;
//----------------------
     0 1 1  ?  : 0 : 0;
     1 1 1  ?  : 1 : 1;
//----------------------
     ? ? ? (?1): ? : -;
  (??) ? ?  ?  : ? : -;
     ? ? r  0  : ? : -;
     ? ? r  1  : ? : -;
     ? r ?  0  : ? : -;
     ? r ?  1  : ? : -;
    endtable
endprimitive
`endcelldefine

`celldefine
primitive ads_prim_lat_pc_p (q, d, e, p, c);
   output q;
   input d,e,p,c;
// latch, active high enable, preset, clear
   reg q;
   table
// d e p c q_state q
   ? ? ? 0 :  ?  : 0;
   ? ? 0 1 :  ?  : 1;
   1 1 1 1 :  ?  : 1;
   0 1 1 1 :  ?  : 0;
   ? 0 1 1 :  ?  : -;
   0 ? 1 ? :  0  : 0;
   1 ? ? 1 :  1  : 1;
   endtable
endprimitive
`endcelldefine

`celldefine
primitive ads_prim_lat_pc_n (q, d, e, p, c);
   output q;
   input d,e,p,c;
// latch, active low enable, preset, clear
   reg q;
   table
// d e p c q_state q
   ? ? ? 0 :  ?  : 0;
   ? ? 0 1 :  ?  : 1;
   1 0 1 1 :  ?  : 1;
   0 0 1 1 :  ?  : 0;
   ? 1 1 1 :  ?  : -;
   0 ? 1 ? :  0  : 0;
   1 ? ? 1 :  1  : 1;
   endtable
endprimitive
`endcelldefine
